# generated by datamodel-codegen:
#   filename:  event-api-openapi.json
#   timestamp: 2024-05-03T15:29:57+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional, Union

from pydantic import BaseModel, Field


class Connection(BaseModel):
    id: Optional[int] = Field(None, title='Id')
    created_at: Optional[datetime] = Field(
        '2024-04-27T03:22:46.716266', title='Created At'
    )
    session_id: Optional[int] = Field(None, title='Session Id')
    is_active: Optional[bool] = Field(False, title='Is Active')
    start_time: datetime = Field(..., title='Start Time')
    end_time: Optional[datetime] = Field(None, title='End Time')


class CreateConnection(BaseModel):
    session_id: int = Field(..., title='Session Id')
    start_time: Optional[datetime] = Field(
        '2024-04-27T03:22:46.722048', title='Start Time'
    )


class ListResponseConnection(BaseModel):
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.717171', title='Timestamp'
    )
    results: List[Connection] = Field(..., title='Results')
    count: Optional[int] = Field(None, title='Count')


class Message(BaseModel):
    id: Optional[int] = Field(None, title='Id')
    created_at: Optional[datetime] = Field(
        '2024-04-27T03:22:46.716266', title='Created At'
    )
    topic: str = Field(..., title='Topic')
    message: str = Field(..., title='Message')
    connection_id: Optional[int] = Field(None, title='Connection Id')
    session_id: Optional[int] = Field(None, title='Session Id')
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.726648', title='Timestamp'
    )


class MessageCreate(BaseModel):
    topic: str = Field(..., title='Topic')
    message: str = Field(..., title='Message')


class Status(Enum):
    CREATED = 'CREATED'
    CONNECTED = 'CONNECTED'
    DISCONNECTED = 'DISCONNECTED'
    DELETED = 'DELETED'
    ERROR = 'ERROR'


class Subscriber(BaseModel):
    id: Optional[int] = Field(None, title='Id')
    created_at: Optional[datetime] = Field(
        '2024-04-27T03:22:46.716266', title='Created At'
    )
    user_id: str = Field(..., title='User Id')


class SubscriptionCreate(BaseModel):
    topic: str = Field(..., title='Topic')
    subscriber_id: int = Field(..., title='Subscriber Id')


class Subscription(BaseModel):
    id: Optional[int] = Field(None, title='Id')
    created_at: Optional[datetime] = Field(
        '2024-04-27T03:22:46.716266', title='Created At'
    )
    subscriber_id: Optional[int] = Field(None, title='Subscriber Id')
    topic: str = Field(..., title='Topic')


class ValidationError(BaseModel):
    loc: List[Union[str, int]] = Field(..., title='Location')
    msg: str = Field(..., title='Message')
    type: str = Field(..., title='Error Type')


class HTTPValidationError(BaseModel):
    detail: Optional[List[ValidationError]] = Field(None, title='Detail')


class ListResponseMessage(BaseModel):
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.717171', title='Timestamp'
    )
    results: List[Message] = Field(..., title='Results')
    count: Optional[int] = Field(None, title='Count')


class ListResponseSubscriber(BaseModel):
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.717171', title='Timestamp'
    )
    results: List[Subscriber] = Field(..., title='Results')
    count: Optional[int] = Field(None, title='Count')


class ListResponseSubscription(BaseModel):
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.717171', title='Timestamp'
    )
    results: List[Subscription] = Field(..., title='Results')
    count: Optional[int] = Field(None, title='Count')


class Session(BaseModel):
    id: Optional[int] = Field(None, title='Id')
    created_at: Optional[datetime] = Field(
        '2024-04-27T03:22:46.716266', title='Created At'
    )
    subscriber_id: Optional[int] = Field(None, title='Subscriber Id')
    status: Optional[Status] = 'CREATED'
    last_connected: Optional[datetime] = Field(
        '2024-04-27T03:22:46.720380', title='Last Connected'
    )
    token: str = Field(..., title='Token')


class ListResponseSession(BaseModel):
    timestamp: Optional[datetime] = Field(
        '2024-04-27T03:22:46.717171', title='Timestamp'
    )
    results: List[Session] = Field(..., title='Results')
    count: Optional[int] = Field(None, title='Count')
